> ## Documentation Index
> Fetch the complete documentation index at: https://docs.domino.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Fetch a list of :ref:`ref_flyteidl.admin.NodeExecution`



## OpenAPI

````yaml /api-specs/cloud/flyte-native-api.yaml get /api/v1/node_executions/{workflow_execution_id.project}/{workflow_execution_id.domain}/{workflow_execution_id.name}
openapi: 3.0.0
info:
  title: flyteidl/service/admin.proto
  version: version not set
servers:
  - url: https://mycluster.domino.tech
    description: >-
      Replace 'mycluster.domino.tech' with your Domino cluster hostname. For
      Domino Cloud customers, that is <your-subdomain>.domino.tech (e.g.,
      acme.domino.tech). For self-hosted deployments, it is the hostname you
      reach the Domino UI at.
security: []
tags:
  - name: AdminService
paths:
  /api/v1/node_executions/{workflow_execution_id.project}/{workflow_execution_id.domain}/{workflow_execution_id.name}:
    get:
      tags:
        - AdminService
      summary: Fetch a list of :ref:`ref_flyteidl.admin.NodeExecution`
      operationId: AdminService_ListNodeExecutions
      parameters:
        - name: workflow_execution_id.project
          description: Name of the project the resource belongs to.
          in: path
          required: true
          schema:
            type: string
        - name: workflow_execution_id.domain
          description: |-
            Name of the domain the resource belongs to.
            A domain can be considered as a subset within a specific project.
          in: path
          required: true
          schema:
            type: string
        - name: workflow_execution_id.name
          description: User or system provided value for the resource.
          in: path
          required: true
          schema:
            type: string
        - name: workflow_execution_id.org
          description: Optional, org key applied to the resource.
          in: query
          required: false
          schema:
            type: string
        - name: limit
          description: |-
            Indicates the number of resources to be returned.
            +required
          in: query
          required: false
          schema:
            type: integer
            format: int64
        - name: token
          in: query
          required: false
          schema:
            type: string
        - name: filters
          description: |-
            Indicates a list of filters passed as string.
            More info on constructing filters : <Link>
            +optional
          in: query
          required: false
          schema:
            type: string
        - name: sort_by.key
          description: |-
            Indicates an attribute to sort the response values.
            +required
          in: query
          required: false
          schema:
            type: string
        - name: sort_by.direction
          description: |-
            Indicates the direction to apply sort key for response values.
            +optional

             - DESCENDING: By default, fields are sorted in descending order.
          in: query
          required: false
          schema:
            type: string
            enum:
              - DESCENDING
              - ASCENDING
            default: DESCENDING
        - name: unique_parent_id
          description: |-
            Unique identifier of the parent node in the execution
            +optional
          in: query
          required: false
          schema:
            type: string
      responses:
        '200':
          description: A successful response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/adminNodeExecutionList'
        default:
          description: An unexpected error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/googlerpcStatus'
components:
  schemas:
    adminNodeExecutionList:
      type: object
      properties:
        node_executions:
          type: array
          items:
            $ref: '#/components/schemas/flyteidladminNodeExecution'
        token:
          type: string
          description: >-
            In the case of multiple pages of results, the server-provided token
            can be used to fetch the next page

            in a query. If there are no more results, this value will be empty.
      title: |-
        Request structure to retrieve a list of node execution entities.
        See :ref:`ref_flyteidl.admin.NodeExecution` for more details
    googlerpcStatus:
      type: object
      properties:
        code:
          type: integer
          format: int32
        message:
          type: string
        details:
          type: array
          items:
            $ref: '#/components/schemas/protobufAny'
    flyteidladminNodeExecution:
      type: object
      properties:
        id:
          $ref: '#/components/schemas/coreNodeExecutionIdentifier'
        input_uri:
          type: string
          description: Path to remote data store where input blob is stored.
        closure:
          $ref: '#/components/schemas/adminNodeExecutionClosure'
        metadata:
          $ref: '#/components/schemas/adminNodeExecutionMetaData'
      description: >-
        Encapsulates all details for a single node execution entity.

        A node represents a component in the overall workflow graph. A node
        launch a task, multiple tasks, an entire nested

        sub-workflow, or even a separate child-workflow execution.

        The same task can be called repeatedly in a single workflow but each
        node is unique.
    protobufAny:
      type: object
      properties:
        '@type':
          type: string
          description: >-
            A URL/resource name that uniquely identifies the type of the
            serialized

            protocol buffer message. This string must contain at least

            one "/" character. The last segment of the URL's path must represent

            the fully qualified name of the type (as in

            `path/google.protobuf.Duration`). The name should be in a canonical
            form

            (e.g., leading "." is not accepted).


            In practice, teams usually precompile into the binary all types that
            they

            expect it to use in the context of Any. However, for URLs which use
            the

            scheme `http`, `https`, or no scheme, one can optionally set up a
            type

            server that maps type URLs to message definitions as follows:


            * If no scheme is provided, `https` is assumed.

            * An HTTP GET on the URL must yield a [google.protobuf.Type][]
              value in binary format, or produce an error.
            * Applications are allowed to cache lookup results based on the
              URL, or have them precompiled into a binary to avoid any
              lookup. Therefore, binary compatibility needs to be preserved
              on changes to types. (Use versioned type names to manage
              breaking changes.)

            Note: this functionality is not currently available in the official

            protobuf release, and it is not used for type URLs beginning with

            type.googleapis.com. As of May 2023, there are no widely used type
            server

            implementations and no plans to implement one.


            Schemes other than `http`, `https` (or the empty scheme) might be

            used with implementation specific semantics.
      additionalProperties: {}
      description: >-
        `Any` contains an arbitrary serialized protocol buffer message along
        with a

        URL that describes the type of the serialized message.


        Protobuf library provides support to pack/unpack Any values in the form

        of utility functions or additional generated methods of the Any type.


        Example 1: Pack and unpack a message in C++.

            Foo foo = ...;
            Any any;
            any.PackFrom(foo);
            ...
            if (any.UnpackTo(&foo)) {
              ...
            }

        Example 2: Pack and unpack a message in Java.

            Foo foo = ...;
            Any any = Any.pack(foo);
            ...
            if (any.is(Foo.class)) {
              foo = any.unpack(Foo.class);
            }
            // or ...
            if (any.isSameTypeAs(Foo.getDefaultInstance())) {
              foo = any.unpack(Foo.getDefaultInstance());
            }

         Example 3: Pack and unpack a message in Python.

            foo = Foo(...)
            any = Any()
            any.Pack(foo)
            ...
            if any.Is(Foo.DESCRIPTOR):
              any.Unpack(foo)
              ...

         Example 4: Pack and unpack a message in Go

             foo := &pb.Foo{...}
             any, err := anypb.New(foo)
             if err != nil {
               ...
             }
             ...
             foo := &pb.Foo{}
             if err := any.UnmarshalTo(foo); err != nil {
               ...
             }

        The pack methods provided by protobuf library will by default use

        'type.googleapis.com/full.type.name' as the type URL and the unpack

        methods only use the fully qualified type name after the last '/'

        in the type URL, for example "foo.bar.com/x/y.z" will yield type

        name "y.z".


        JSON

        ====

        The JSON representation of an `Any` value uses the regular

        representation of the deserialized, embedded message, with an

        additional field `@type` which contains the type URL. Example:

            package google.profile;
            message Person {
              string first_name = 1;
              string last_name = 2;
            }

            {
              "@type": "type.googleapis.com/google.profile.Person",
              "firstName": <string>,
              "lastName": <string>
            }

        If the embedded message type is well-known and has a custom JSON

        representation, that representation will be embedded adding a field

        `value` which holds the custom JSON in addition to the `@type`

        field. Example (for message [google.protobuf.Duration][]):

            {
              "@type": "type.googleapis.com/google.protobuf.Duration",
              "value": "1.212s"
            }
    coreNodeExecutionIdentifier:
      type: object
      properties:
        node_id:
          type: string
        execution_id:
          $ref: '#/components/schemas/coreWorkflowExecutionIdentifier'
      description: Encapsulation of fields that identify a Flyte node execution entity.
    adminNodeExecutionClosure:
      type: object
      properties:
        output_uri:
          type: string
          description: >-
            Links to a remotely stored, serialized core.LiteralMap of node
            execution outputs.

            DEPRECATED. Use GetNodeExecutionData to fetch output data instead.
        error:
          $ref: '#/components/schemas/coreExecutionError'
        output_data:
          $ref: '#/components/schemas/coreLiteralMap'
        phase:
          $ref: '#/components/schemas/coreNodeExecutionPhase'
        started_at:
          type: string
          format: date-time
          description: Time at which the node execution began running.
        duration:
          type: string
          description: The amount of time the node execution spent running.
        created_at:
          type: string
          format: date-time
          description: Time at which the node execution was created.
        updated_at:
          type: string
          format: date-time
          description: Time at which the node execution was last updated.
        workflow_node_metadata:
          $ref: '#/components/schemas/flyteidladminWorkflowNodeMetadata'
        task_node_metadata:
          $ref: '#/components/schemas/flyteidladminTaskNodeMetadata'
        deck_uri:
          type: string
          title: >-
            String location uniquely identifying where the deck HTML file is.

            NativeUrl specifies the url in the format of the configured storage
            provider (e.g. s3://my-bucket/randomstring/suffix.tar)
        dynamic_job_spec_uri:
          type: string
          description: >-
            dynamic_job_spec_uri is the location of the DynamicJobSpec proto
            message for a DynamicWorkflow. This is required

            to correctly recover partially completed executions where the
            subworkflow has already been compiled.
      description: Container for node execution details and results.
    adminNodeExecutionMetaData:
      type: object
      properties:
        retry_group:
          type: string
          description: |-
            Node executions are grouped depending on retries of the parent
            Retry group is unique within the context of a parent node.
        is_parent_node:
          type: boolean
          description: >-
            Boolean flag indicating if the node has child nodes under it

            This can be true when a node contains a dynamic workflow which then
            produces

            child nodes.
        spec_node_id:
          type: string
          title: |-
            Node id of the node in the original workflow
            This maps to value of WorkflowTemplate.nodes[X].id
        is_dynamic:
          type: boolean
          description: >-
            Boolean flag indicating if the node has contains a dynamic workflow
            which then produces child nodes.

            This is to distinguish between subworkflows and dynamic workflows
            which can both have is_parent_node as true.
        is_array:
          type: boolean
          description: >-
            Boolean flag indicating if the node is an array node. This is
            intended to uniquely identify

            array nodes from other nodes which can have is_parent_node as true.
        is_eager:
          type: boolean
          description: Whether this node is an eager node.
      title: Represents additional attributes related to a Node Execution
    coreWorkflowExecutionIdentifier:
      type: object
      properties:
        project:
          type: string
          description: Name of the project the resource belongs to.
        domain:
          type: string
          description: |-
            Name of the domain the resource belongs to.
            A domain can be considered as a subset within a specific project.
        name:
          type: string
          description: User or system provided value for the resource.
        org:
          type: string
          description: Optional, org key applied to the resource.
      title: >-
        Encapsulation of fields that uniquely identifies a Flyte workflow
        execution
    coreExecutionError:
      type: object
      properties:
        code:
          type: string
          title: |-
            Error code indicates a grouping of a type of error.
            More Info: <Link>
        message:
          type: string
          description: Detailed description of the error - including stack trace.
        error_uri:
          type: string
          title: Full error contents accessible via a URI
        kind:
          $ref: '#/components/schemas/ExecutionErrorErrorKind'
        timestamp:
          type: string
          format: date-time
          title: Timestamp of the error
        worker:
          type: string
          title: Worker that generated the error
      description: Represents the error message from the execution.
    coreLiteralMap:
      type: object
      properties:
        literals:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/coreLiteral'
      description: >-
        A map of literals. This is a workaround since oneofs in proto messages
        cannot contain a repeated field.
    coreNodeExecutionPhase:
      type: string
      enum:
        - UNDEFINED
        - QUEUED
        - RUNNING
        - SUCCEEDED
        - FAILING
        - FAILED
        - ABORTED
        - SKIPPED
        - TIMED_OUT
        - DYNAMIC_RUNNING
        - RECOVERED
      default: UNDEFINED
    flyteidladminWorkflowNodeMetadata:
      type: object
      properties:
        executionId:
          $ref: '#/components/schemas/coreWorkflowExecutionIdentifier'
      title: Metadata for a WorkflowNode
    flyteidladminTaskNodeMetadata:
      type: object
      properties:
        cache_status:
          $ref: '#/components/schemas/coreCatalogCacheStatus'
        catalog_key:
          $ref: '#/components/schemas/coreCatalogMetadata'
        checkpoint_uri:
          type: string
          title: The latest checkpoint location
      title: Metadata for the case in which the node is a TaskNode
    ExecutionErrorErrorKind:
      type: string
      enum:
        - UNKNOWN
        - USER
        - SYSTEM
      default: UNKNOWN
      title: 'Error type: System or User'
    coreLiteral:
      type: object
      properties:
        scalar:
          $ref: '#/components/schemas/coreScalar'
        collection:
          $ref: '#/components/schemas/coreLiteralCollection'
        map:
          $ref: '#/components/schemas/coreLiteralMap'
        offloaded_metadata:
          $ref: '#/components/schemas/coreLiteralOffloadedMetadata'
        hash:
          type: string
          title: >-
            A hash representing this literal.

            This is used for caching purposes. For more details refer to RFC
            1893

            (https://github.com/flyteorg/flyte/blob/master/rfc/system/1893-caching-of-offloaded-objects.md)
        metadata:
          type: object
          additionalProperties:
            type: string
          description: Additional metadata for literals.
      description: >-
        A simple value. This supports any level of nesting (e.g. array of array
        of array of Blobs) as well as simple primitives.
    coreCatalogCacheStatus:
      type: string
      enum:
        - CACHE_DISABLED
        - CACHE_MISS
        - CACHE_HIT
        - CACHE_POPULATED
        - CACHE_LOOKUP_FAILURE
        - CACHE_PUT_FAILURE
        - CACHE_SKIPPED
        - CACHE_EVICTED
      default: CACHE_DISABLED
      description: |-
        - CACHE_DISABLED: Used to indicate that caching was disabled
         - CACHE_MISS: Used to indicate that the cache lookup resulted in no matches
         - CACHE_HIT: used to indicate that the associated artifact was a result of a previous execution
         - CACHE_POPULATED: used to indicate that the resultant artifact was added to the cache
         - CACHE_LOOKUP_FAILURE: Used to indicate that cache lookup failed because of an error
         - CACHE_PUT_FAILURE: Used to indicate that cache lookup failed because of an error
         - CACHE_SKIPPED: Used to indicate the cache lookup was skipped
         - CACHE_EVICTED: Used to indicate that the cache was evicted
      title: >-
        Indicates the status of CatalogCaching. The reason why this is not
        embedded in TaskNodeMetadata is, that we may use for other types of
        nodes as well in the future
    coreCatalogMetadata:
      type: object
      properties:
        dataset_id:
          $ref: '#/components/schemas/coreIdentifier'
        artifact_tag:
          $ref: '#/components/schemas/coreCatalogArtifactTag'
        source_task_execution:
          $ref: '#/components/schemas/coreTaskExecutionIdentifier'
      title: Catalog artifact information with specific metadata
    coreScalar:
      type: object
      properties:
        primitive:
          $ref: '#/components/schemas/corePrimitive'
        blob:
          $ref: '#/components/schemas/coreBlob'
        binary:
          $ref: '#/components/schemas/coreBinary'
        schema:
          $ref: '#/components/schemas/flyteidlcoreSchema'
        none_type:
          $ref: '#/components/schemas/coreVoid'
        error:
          $ref: '#/components/schemas/coreError'
        generic:
          type: object
        structured_dataset:
          $ref: '#/components/schemas/coreStructuredDataset'
        union:
          $ref: '#/components/schemas/coreUnion'
    coreLiteralCollection:
      type: object
      properties:
        literals:
          type: array
          items:
            $ref: '#/components/schemas/coreLiteral'
      description: >-
        A collection of literals. This is a workaround since oneofs in proto
        messages cannot contain a repeated field.
    coreLiteralOffloadedMetadata:
      type: object
      properties:
        uri:
          type: string
          description: The location of the offloaded core.Literal.
        size_bytes:
          type: string
          format: uint64
          description: The size of the offloaded data.
        inferred_type:
          $ref: '#/components/schemas/coreLiteralType'
      description: A message that contains the metadata of the offloaded data.
    coreIdentifier:
      type: object
      properties:
        resource_type:
          $ref: '#/components/schemas/coreResourceType'
        project:
          type: string
          description: Name of the project the resource belongs to.
        domain:
          type: string
          description: |-
            Name of the domain the resource belongs to.
            A domain can be considered as a subset within a specific project.
        name:
          type: string
          description: User provided value for the resource.
        version:
          type: string
          description: Specific version of the resource.
        org:
          type: string
          description: Optional, org key applied to the resource.
      description: Encapsulation of fields that uniquely identifies a Flyte resource.
    coreCatalogArtifactTag:
      type: object
      properties:
        artifact_id:
          type: string
          title: Artifact ID is generated name
        name:
          type: string
          title: Flyte computes the tag automatically, as the hash of the values
    coreTaskExecutionIdentifier:
      type: object
      properties:
        task_id:
          $ref: '#/components/schemas/coreIdentifier'
        node_execution_id:
          $ref: '#/components/schemas/coreNodeExecutionIdentifier'
        retry_attempt:
          type: integer
          format: int64
      description: Encapsulation of fields that identify a Flyte task execution entity.
    corePrimitive:
      type: object
      properties:
        integer:
          type: string
          format: int64
        float_value:
          type: number
          format: double
        string_value:
          type: string
        boolean:
          type: boolean
        datetime:
          type: string
          format: date-time
        duration:
          type: string
      title: Primitive Types
    coreBlob:
      type: object
      properties:
        metadata:
          $ref: '#/components/schemas/coreBlobMetadata'
        uri:
          type: string
      description: >-
        Refers to an offloaded set of files. It encapsulates the type of the
        store and a unique uri for where the data is.

        There are no restrictions on how the uri is formatted since it will
        depend on how to interact with the store.
    coreBinary:
      type: object
      properties:
        value:
          type: string
          format: byte
          description: >-
            Serialized data (MessagePack) for supported types like Dataclass,
            Pydantic BaseModel, and untyped dict.
        tag:
          type: string
          description: >-
            The serialization format identifier (e.g., MessagePack). Consumers
            must define unique tags and validate them before deserialization.
      description: >-
        A simple byte array with a tag to help different parts of the system
        communicate about what is in the byte array.

        It's strongly advisable that consumers of this type define a unique tag
        and validate the tag before parsing the data.
    flyteidlcoreSchema:
      type: object
      properties:
        uri:
          type: string
        type:
          $ref: '#/components/schemas/coreSchemaType'
      description: >-
        A strongly typed schema that defines the interface of data retrieved
        from the underlying storage medium.
    coreVoid:
      type: object
      description: >-
        Used to denote a nil/null/None assignment to a scalar value. The
        underlying LiteralType for Void is intentionally

        undefined since it can be assigned to a scalar of any LiteralType.
    coreError:
      type: object
      properties:
        failed_node_id:
          type: string
          description: The node id that threw the error.
        message:
          type: string
          description: Error message thrown.
      description: Represents an error thrown from a node.
    coreStructuredDataset:
      type: object
      properties:
        uri:
          type: string
          title: >-
            String location uniquely identifying where the data is.

            Should start with the storage location (e.g. s3://, gs://, bq://,
            etc.)
        metadata:
          $ref: '#/components/schemas/coreStructuredDatasetMetadata'
    coreUnion:
      type: object
      properties:
        value:
          $ref: '#/components/schemas/coreLiteral'
        type:
          $ref: '#/components/schemas/coreLiteralType'
      description: >-
        The runtime representation of a tagged union value. See `UnionType` for
        more details.
    coreLiteralType:
      type: object
      properties:
        simple:
          $ref: '#/components/schemas/coreSimpleType'
        schema:
          $ref: '#/components/schemas/coreSchemaType'
        collection_type:
          $ref: '#/components/schemas/coreLiteralType'
        map_value_type:
          $ref: '#/components/schemas/coreLiteralType'
        blob:
          $ref: '#/components/schemas/coreBlobType'
        enum_type:
          $ref: '#/components/schemas/flyteidlcoreEnumType'
        structured_dataset_type:
          $ref: '#/components/schemas/coreStructuredDatasetType'
        union_type:
          $ref: '#/components/schemas/coreUnionType'
        metadata:
          type: object
          description: >-
            This field contains type metadata that is descriptive of the type,
            but is NOT considered in type-checking.  This might be used by

            consumers to identify special behavior or display extended
            information for the type.
        annotation:
          $ref: '#/components/schemas/coreTypeAnnotation'
        structure:
          $ref: '#/components/schemas/coreTypeStructure'
      description: Defines a strong type to allow type checking between interfaces.
    coreResourceType:
      type: string
      enum:
        - UNSPECIFIED
        - TASK
        - WORKFLOW
        - LAUNCH_PLAN
        - DATASET
      default: UNSPECIFIED
      description: >-
        Indicates a resource type within Flyte.

         - DATASET: A dataset represents an entity modeled in Flyte DataCatalog. A Dataset is also a versioned entity and can be a compilation of multiple individual objects.
        Eventually all Catalog objects should be modeled similar to Flyte
        Objects. The Dataset entities makes it possible for the UI  and CLI to
        act on the objects 

        in a similar manner to other Flyte objects
    coreBlobMetadata:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/coreBlobType'
    coreSchemaType:
      type: object
      properties:
        columns:
          type: array
          items:
            $ref: '#/components/schemas/SchemaTypeSchemaColumn'
          description: A list of ordered columns this schema comprises of.
      description: >-
        Defines schema columns and types to strongly type-validate schemas
        interoperability.
    coreStructuredDatasetMetadata:
      type: object
      properties:
        structured_dataset_type:
          $ref: '#/components/schemas/coreStructuredDatasetType'
    coreSimpleType:
      type: string
      enum:
        - NONE
        - INTEGER
        - FLOAT
        - STRING
        - BOOLEAN
        - DATETIME
        - DURATION
        - BINARY
        - ERROR
        - STRUCT
      default: NONE
      description: Define a set of simple types.
    coreBlobType:
      type: object
      properties:
        format:
          type: string
          title: |-
            Format can be a free form string understood by SDK/UI etc like
            csv, parquet etc
        dimensionality:
          $ref: '#/components/schemas/BlobTypeBlobDimensionality'
      title: Defines type behavior for blob objects
    flyteidlcoreEnumType:
      type: object
      properties:
        values:
          type: array
          items:
            type: string
          description: Predefined set of enum values.
      description: >-
        Enables declaring enum types, with predefined string values

        For len(values) > 0, the first value in the ordered list is regarded as
        the default value. If you wish

        To provide no defaults, make the first value as undefined.
    coreStructuredDatasetType:
      type: object
      properties:
        columns:
          type: array
          items:
            $ref: '#/components/schemas/StructuredDatasetTypeDatasetColumn'
          description: A list of ordered columns this schema comprises of.
        format:
          type: string
          description: >-
            This is the storage format, the format of the bits at rest

            parquet, feather, csv, etc.

            For two types to be compatible, the format will need to be an exact
            match.
        external_schema_type:
          type: string
          description: >-
            This is a string representing the type that the bytes in
            external_schema_bytes are formatted in.

            This is an optional field that will not be used for type checking.
        external_schema_bytes:
          type: string
          format: byte
          description: |-
            The serialized bytes of a third-party schema library like Arrow.
            This is an optional field that will not be used for type checking.
    coreUnionType:
      type: object
      properties:
        variants:
          type: array
          items:
            $ref: '#/components/schemas/coreLiteralType'
          description: Predefined set of variants in union.
      description: >-
        Defines a tagged union type, also known as a variant (and formally as
        the sum type).


        A sum type S is defined by a sequence of types (A, B, C, ...), each
        tagged by a string tag

        A value of type S is constructed from a value of any of the variant
        types. The specific choice of type is recorded by

        storing the varaint's tag with the literal value and can be examined in
        runtime.


        Type S is typically written as

        S := Apple A | Banana B | Cantaloupe C | ...


        Notably, a nullable (optional) type is a sum type between some type X
        and the singleton type representing a null-value:

        Optional X := X | Null


        See also: https://en.wikipedia.org/wiki/Tagged_union
    coreTypeAnnotation:
      type: object
      properties:
        annotations:
          type: object
          description: A arbitrary JSON payload to describe a type.
      description: >-
        TypeAnnotation encapsulates registration time information about a type.
        This can be used for various control-plane operations. TypeAnnotation
        will not be available at runtime when a task runs.
    coreTypeStructure:
      type: object
      properties:
        tag:
          type: string
          title: Must exactly match for types to be castable
        dataclass_type:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/coreLiteralType'
          title: >-
            dataclass_type only exists for dataclasses.

            This is used to resolve the type of the fields of dataclass

            The key is the field name, and the value is the literal type of the
            field

            e.g. For dataclass Foo, with fields a, and a is a string

            Foo.a will be resolved as a literal type of string from
            dataclass_type
      description: |-
        Hints to improve type matching
        e.g. allows distinguishing output from custom type transformers
        even if the underlying IDL serialization matches.
    SchemaTypeSchemaColumn:
      type: object
      properties:
        name:
          type: string
          title: A unique name -within the schema type- for the column
        type:
          $ref: '#/components/schemas/SchemaColumnSchemaColumnType'
    BlobTypeBlobDimensionality:
      type: string
      enum:
        - SINGLE
        - MULTIPART
      default: SINGLE
    StructuredDatasetTypeDatasetColumn:
      type: object
      properties:
        name:
          type: string
          description: A unique name within the schema type for the column.
        literal_type:
          $ref: '#/components/schemas/coreLiteralType'
    SchemaColumnSchemaColumnType:
      type: string
      enum:
        - INTEGER
        - FLOAT
        - STRING
        - BOOLEAN
        - DATETIME
        - DURATION
      default: INTEGER

````